#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "UpdateSpread", Category = "String", Help = "Basic template with one string in/out", Tags = "")]
	#endregion PluginInfo
	public class StringUpdateSpreadNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Default", DefaultString= "text")]
		ISpread<string> FDefault;
		
		[Input("Input", DefaultString = "text")]
		ISpread<string> FInput;
		
        [Input("Index", DefaultValue = 0)]
		ISpread<int> FIndex;
		
		[Input("Update", IsBang=true)]
		ISpread<bool> FUpdate;
		
		[Input("Initialize", IsBang=true)]
		ISpread<bool> FInitialize;
		
		[Output("Output")]
		ISpread<string> FOutput;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		int OutputSliceCount=0;

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = OutputSliceCount;
            if(FInitialize[0])
            {    
            	OutputSliceCount = FDefault.SliceCount;
            	FOutput.SliceCount = SpreadMax;
			    for (int i = 0; i < SpreadMax; i++)
					FOutput[i] = FDefault[i];				
			}
			if(FUpdate[0])
			{
			    for (int i = 0; i < FIndex.SliceCount; i++)
			    {
			   		FOutput[FIndex[i]] = FInput[i];
			   	}
			}
			//FLogger.Log(LogType.Debug, "Logging to Renderer (TTY)");
		}
	}
}
